package com.ruoyi.framework.config;


import com.baomidou.mybatisplus.core.handlers.MetaObjectHandler;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.utils.SecurityUtils;
import org.apache.ibatis.reflection.MetaObject;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.util.Objects;

/**
 * 自动注入
 *
 * @author wu
 * @since 2023/5/4 10:16
 */
@Component
public class MyMetaObjectHandler implements MetaObjectHandler {

    @Override
    public void insertFill(MetaObject metaObject) {
        // 获取当前登录用户
        LoginUser loginUser = SecurityUtils.getLoginUser();
        String userName = loginUser.getUsername();
        if (!Objects.equals(userName, "")) {
            this.strictInsertFill(metaObject, "createBy", String.class, userName);
        }
        this.strictInsertFill(metaObject, "createTime", LocalDateTime.class, LocalDateTime.now());
    }

    @Override
    public void updateFill(MetaObject metaObject) {
        // 获取当前登录用户
        LoginUser loginUser = SecurityUtils.getLoginUser();

        String userName = loginUser.getUsername();
        if (!Objects.equals(userName, "")) {
            this.strictInsertFill(metaObject, "createBy", String.class, userName);
        }
        this.strictInsertFill(metaObject, "createTime", LocalDateTime.class, LocalDateTime.now());
    }
}
